program jcExtendHeaders
  ! Program to extend the same header values into the same axes
  ! Can currently only handle extending into the third axis, SO IT IS NOT GENERAL
  !
  ! Inputs:
  !   1) header history file
  !   2) axis: axis you would like the extend the headers into
  !   3) naxis: number of values you would like to extend over the axis
  !
  ! Output:
  !   1) header history file with an extra dimension

  use sep
  implicit none

  ! declare variables
  integer                            :: ii,jj
  integer                            :: n1,n2,n3
  integer                            :: naxis
  real,allocatable,dimension (:,:)   :: in
  real,allocatable,dimension (:,:,:) :: out

  ! open I/O
  call sep_init()

  call from_history('n1',n1,1)
  call from_history('n2',n2,1)
  call from_history('n3',n3,1)

  call from_param('naxis',naxis,2)

  call to_history('n1',n1   )
  call to_history('n2',n2   )
  call to_history('n3',naxis)

  call sep_close()

  ! allocate
  allocate(in(n1,n2),out(n1,n2,naxis))

  ! read in
  call sreed('in',in,4*n1*n2)

  do jj=1,n2
    do ii=1,n1
      out(ii,jj,:) = in(ii,jj)
    end do
  end do

  ! write out
  call srite('out',out,4*n1*n2*naxis)

  ! clean up
  deallocate(in,out)

end program
