program jcXY2cmplx
! Jason P. Chang
! June 2012
!
! convert two real values to a single complex number
! originally for creating a stations map in Grey
! need to window the x and y coordinates
!
! Order: order of x and y coordinates
!   - 1: x is first index, y is second index [default]
!   - 2: y is first index, x is second index
  
  use sep
  implicit none
  
  ! allocate variables
  integer                              :: order
  integer                              :: i
  integer                              :: n1,n2
  real                                 :: a,b
  complex,allocatable,dimension   (:)  :: out
  real   ,allocatable,dimension (:,:)  :: in
  
  ! open I/O
  call sep_init()

  call from_history('n1'   ,n1     )
  call from_history('n2'   ,n2     )
  call from_param  ('order',order,1)
  
  call to_history('n1',  n2)
  call to_history('n2',   1)
  call to_history('esize',8)

  call sep_close()

  ! allocate
  allocate(in (n1,n2))
  allocate(out   (n2))

  ! read in the coordinates
  call sep_read(in)

  ! form the complex value
  do i=1,n2
    if ( order .eq. 1 ) then
      out(i) = cmplx( in(1,i), in(2,i) )
    else
      out(i) = cmplx( in(2,i), in(1,i) )
    end if
  end do

  ! write out result
  call sep_write(out)

  ! clean up
  deallocate(in,out)
  call exit(0)
  
end program jcXY2cmplx
