#! /usr/bin/env python
# Python module for dispersion curve inversion functions
# 
# includes receiver x and receiver y

# year:month:day:hour:minute:second:microsecond

import commands
import sys
import os
from array import array
import random

startime       = sys.argv[1]
duration       = sys.argv[2]
outputfilename = sys.argv[3]
tmp_name   = random.randint(0,10000)

taperlength  = 2.5*60 # 2.5 minutes (in seconds)

startimelist = startime.split(':')
durationlist = duration.split(':')
#print startimelist
#print durationlist

# For kept trace headers
keys=['hdrkey1="traceNumber" hdrtype1="scalar_float" hdrfmt1="xdr_float"\n', \
'hdrkey2="fileNumber" hdrtype2="scalar_float" hdrfmt2="xdr_float"\n', \
'hdrkey3="receiverLine" hdrtype3="scalar_float" hdrfmt3="xdr_float"\n', \
'hdrkey4="receiverPoint" hdrtype4="scalar_float" hdrfmt4="xdr_float"\n', \
'hdrkey5="receiverPointIndex" hdrtype5="scalar_float" hdrfmt5="xdr_float"\n', \
'hdrkey6="receiverPointFinalX" hdrtype6="scalar_float" hdrfmt6="xdr_float"\n', \
'hdrkey7="receiverPointFinalY" hdrtype7="scalar_float" hdrfmt7="xdr_float"\n', \
'hdrkey8="receiverPointFinalDepth" hdrtype8="scalar_float" hdrfmt8="xdr_float"\n', \
'hdrkey9="easting" hdrtype9="scalar_float" hdrfmt9="xdr_float"\n', \
'hdrkey10="northing" hdrtype10="scalar_float" hdrfmt10="xdr_float"\n', \
'hdrkey11="elevation" hdrtype11="scalar_float" hdrfmt11="xdr_float"\n']



def getseconds(intime):
  if len(intime)!=7:
    print 'Problem with timeconverter'
    sys.exit()
  outtime = int(intime[1])*31*24*60*60+int(intime[2])*24*60*60+int(intime[3])*60*60+int(intime[4])*60+int(intime[5])
  return outtime


def cat_files(fnames,target):
  block=20
  nfiles=len(fnames)

  ## Strip the headers
  #for ii in range(nfiles):
  #  f=open(fnames[ii],'a')
  #  f.writelines("hff=-1\n")
  #  f.close()

  count2=0
  while 1:
    total=len(fnames)
 #  print total
 #   print fnames
    cnames = []
    
 #  print 'Block division:'
 #  print total//block,total%block
    
    count1=0
    if (total//block>1):
      # For all complete blocks
      for ii in range(total//block):
        names = fnames[(count1)*block:(count1+1)*block]
        cname = 'temp%s_%i.H' %(str(count2),tmp_name)
        print "Cat3d %s axis=2 > %s" %(" ".join(names),cname)
        print commands.getstatusoutput("Cat3d max_memory=1000 %s axis=2 > %s" %(" ".join(names),cname))
        cnames.append(cname)
        for jj in names:
          commands.getstatusoutput("Rm %s %s@@"%(jj,jj))
        count1 = count1+1
        count2 = count2+1
        
      # For the remainder complete blocks
      if (total%block==1): # If only one file
        cname = fnames[count1*block]
        cnames.append(cname)
        
        count1 = count1+1
        count2 = count2+1

      if (total%block>1):
        names = fnames[count1*block:count1*block+total%block]
        cname = 'temp%s_%i.H' %(str(count2),tmp_name)
        print "Cat3d %s axis=2 > %s" %(" ".join(names),cname)
        print commands.getstatusoutput("Cat3d max_memory=1000 %s axis=2 > %s" %(" ".join(names),cname))
        cnames.append(cname)
        for jj in names:
          commands.getstatusoutput("Rm %s %s@@"%(jj,jj))
        count1 = count1+1
        count2 = count2+1
      
      # Repeat with new list
      fnames=cnames
      
    else:
      names = fnames
      print "Cat3d %s axis=2 > %s" %(" ".join(names),target)
      print commands.getstatusoutput("Cat3d max_memory=1000 %s axis=2 > %s" %(" ".join(names),target))
      cnames.append(target)
      for jj in names:
        commands.getstatusoutput("Rm %s %s@@"%(jj,jj))
      break



# Find all files in the datafolder
allinfiles = []
for i in range(1,31):
  datafolder = '/data1/signalhill/C%s' %(i)
  for root,dir,files in os.walk(datafolder):
    for infile in files:
      allinfiles.append(os.path.join(root,infile))

#datafolder = '/data1/signalhill/C1'
#allinfiles = []
#for root,dir,files in os.walk(datafolder):
#  for infile in files:
#    allinfiles.append(os.path.join(root,infile))

# Only keep SEPlib main history files
allfiles = []
for infile in allinfiles:
  if infile[-2:]=='.H':
    allfiles.append(infile)
allfiles.sort()
print 'Total number of files found: ', len(allfiles)

try:
   dt=float(commands.getoutput('Get <' + allfiles[0] + ' d1 parform=n').rstrip().lstrip())
except:
   dt=1

startsecond =     getseconds(startimelist)
totalsampls = int(getseconds(durationlist)/dt)
tapersampls = int(float(taperlength)/dt)

# For each file, extract a trace of correct time length
traces=[]
cntr=1
for infile in allfiles:
  commands.getoutput('Window < '+ infile +'@@ f1=50 n1=7 n2=1 > tmp.hdr')
  commands.getoutput('echo "data_format=xdr_int" >> tmp.hdr')

  commands.getoutput('sfdd < tmp.hdr type="float" format="native" > tmp.H')
 # print 'file starts',commands.getoutput('Disfil < tmp.H number=n col=7').split()
  sstime=getseconds(commands.getoutput('Disfil < tmp.H number=n col=7').split())
  try:
    n1=int(commands.getoutput('Get <' + infile + ' n1 parform=n').rstrip().lstrip())
  except:
    n1=1
  dn1=int((float(startsecond)-float(sstime))/dt)

  n1_grab = max(min((n1-dn1),totalsampls)-max(-dn1,0),0)
  f1_grab = max(dn1,0)
  pad_bef = max(-dn1,0)
  pad_beh = max(totalsampls-max(min(n1-dn1,n1,totalsampls),0)-max(-dn1,0),0)
  
  grab_time = float(max(min((n1-dn1),totalsampls)-max(-dn1,0),0))*dt # in seconds
  
#  print 'file-n1     : ', n1
#  print 'totalsample : ', totalsampls
#  print 'start offset: ', dn1  
#  print 'start index : ', f1_grab
#  print 'grab n1     : ', n1_grab
#  print 'pad before  : ', pad_bef
#  print 'pad behind  : ', pad_beh
#  print 'grab time   : ', grab_time 
  
  grab_days = int( grab_time/60/60/24)
  grab_hors = int((grab_time/60/60/24-int(grab_time/60/60/24))*24)
  grab_mins = int((grab_time/60/60-int(grab_time/60/60))*60)
  grab_secs = int((grab_time/60-int(grab_time/60))*60)
  grab_samp = n1_grab - int(grab_time)/dt

  tracename='trace%i.H' %(cntr)
  tempname ='temp%i.H'  %(tmp_name)
  if dn1+totalsampls<0 or dn1>n1-1 or n1_grab-tapersampls-tapersampls<0:
    print 'No data from ' + infile
    continue
#    commands.getoutput('Spike n1=' + str(totalsampls) + ' mag=0 d2=1 d3=1 d4=1 d5=1 d6=1 d7=1 d8=1 > ' + tracename )
  else:
    print 'Grabbing %i days, %i hours, %i minutes, %i seconds and %i samples from '%(grab_days,grab_hors,grab_mins,grab_secs,grab_samp) + infile 
    #print 'cp   ' + infile + ' ' + tempname
    commands.getoutput('cp   ' + infile + ' ' + tempname)
    # First save some header values
    #print 'Window < '+ infile +'@@ f1=0  n1=5 n2=1 > tmp.hdr'
    commands.getoutput('Window < '+ infile +'@@ f1=0  n1=5 n2=1 > tmp.hdr')
    commands.getoutput('Window < '+ infile +'@@ f1=33 n1=3 n2=1 > tmp3.H' )
    #print 'Window < '+ infile +'@@ f1=57 n1=3 n2=1 > tmp2.H' 
    commands.getoutput('Window < '+ infile +'@@ f1=57 n1=3 n2=1 > tmp2.H' )
    #print 'echo "data_format=xdr_int" >> tmp.hdr'
    commands.getoutput('echo "data_format=xdr_int" >> tmp.hdr')
    #print 'sfdd < tmp.hdr type="float" format="native" > tmp1.H'
    commands.getoutput('sfdd < tmp.hdr type="float" format="native" > tmp1.H')
    #print 'Cat tmp1.H tmp2.H axis=1 > '+tracename+'@@'
    commands.getoutput('Cat tmp1.H tmp3.H tmp2.H axis=1 > '+tracename+'@@')

    f=open(tracename+"@@",'a')
    f.writelines(keys)
    f.close()

    f=open(tempname,'a')
    f.write('  hff=-1  ')
    f.close()
    # Now grab binary portion
    print              'Window3d < '+tempname+' f1='+str(f1_grab)+' n1='+str(n1_grab)+' max_memory=1000 | ./Bin/srTaper1d.x opt=7 t1_ind=1 t2_ind='+str(tapersampls)+' t3_ind='+str(n1_grab-tapersampls)+' t4_ind='+str(n1_grab)+' |  Pad maxsize=1000 beg1='+str(pad_bef)+' end1='+str(pad_beh)+' > '+tracename
    commands.getoutput('Window3d < '+tempname+' f1='+str(f1_grab)+' n1='+str(n1_grab)+' max_memory=1000 | ./Bin/srTaper1d.x opt=7 t1_ind=1 t2_ind='+str(tapersampls)+' t3_ind='+str(n1_grab-tapersampls)+' t4_ind='+str(n1_grab)+' |  Pad maxsize=1000 beg1='+str(pad_bef)+' end1='+str(pad_beh)+' > '+tracename)

    f=open(tracename,'a')
    f.write('  hff="'+tracename+'@@"\n')
    f.write('   o1=0.00  d1='+str(dt)+'  n1='+str(totalsampls)+'\n')
    f.close()
  
  
  traces.append(tracename)
  cntr=cntr+1



cat_files(traces,outputfilename)


